#include <windows.h>
#include "mouhook.h"
#include "resource.h"

#define COUNTOF(x)  (sizeof(x)/sizeof(x[0]))

#pragma data_seg("SHARED")
#pragma data_seg()
#pragma comment(linker, "/section:SHARED,rws")
#pragma comment(lib, "user32")

__declspec(allocate("SHARED")) HHOOK g_hHook = NULL;
__declspec(allocate("SHARED")) HWND  g_hHost = NULL;
__declspec(allocate("SHARED")) POINT g_ptCli = {0};
__declspec(allocate("SHARED")) TCHAR g_szTxt[512] = {0};

LRESULT CALLBACK MouseProc( int nCode, WPARAM wParam, LPARAM lParam )
{
	if( HC_ACTION == nCode )
	{
		PMOUSEHOOKSTRUCT phs = (PMOUSEHOOKSTRUCT)lParam;
		memcpy( &g_ptCli, &phs->pt, sizeof(POINT) );
		::ScreenToClient( phs->hwnd, &g_ptCli );
		::GetWindowText( phs->hwnd, g_szTxt, COUNTOF(g_szTxt) );
		::SendMessage( g_hHost, WM_COMMAND, ID_UPDATE_MOUCOORD, 0 );
	}
	return ::CallNextHookEx( g_hHook, nCode, wParam, lParam );
}

MOUHOOK_API BOOL SetMouHook( HWND hWnd )
{
	if( g_hHook )
		return FALSE;

	if( ::IsWindow( hWnd ) )	
	{
		g_hHost = hWnd;
		g_hHook = ::SetWindowsHookEx( WH_MOUSE, MouseProc, GetModuleHandle("mouhook.dll"), 0 );
	}

	return (BOOL)g_hHook;
}

MOUHOOK_API void UnhookMouHook()
{
	::UnhookWindowsHookEx( g_hHook );
}

MOUHOOK_API POINT GetMouClientPt()
{
	return g_ptCli;
}

MOUHOOK_API void GetMouWindowText( TCHAR* psz, DWORD dwSize )
{
    if( dwSize > sizeof(g_szTxt) )
    	dwSize = sizeof(g_szTxt);
	lstrcpyn( psz, g_szTxt, dwSize );
}